Index: LMDZ6/branches/contrails/libf/phylmd/lmdz_cloud_optics_prop.f90
===================================================================
--- LMDZ6/branches/contrails/libf/phylmd/lmdz_cloud_optics_prop.f90	(revision 5602)
+++ LMDZ6/branches/contrails/libf/phylmd/lmdz_cloud_optics_prop.f90	(revision 5609)
@@ -11,6 +11,6 @@
     icefrac_optics, dNovrN, ptconv, rnebcon, ccwcon, &
     !--AB contrails
-    contfra, qice_cont, pclc_nocont, pcltau_nocont, pclemi_nocont, &
-    pcltau_cont, pclemi_cont, pch_nocont, pct_cont, &
+    contfra, perscontfra, qice_cont, qice_perscont, pclc_nocont, pcltau_nocont, &
+    pclemi_nocont, pcltau_cont, pclemi_cont, pch_nocont, pct_cont, &
     xfiwp_nocont, xfiwc_nocont, reice_nocont)
 
@@ -119,6 +119,8 @@
 
   !--AB for contrails. All these are used / outputed only if ok_plane_contrail=y
-  REAL, INTENT(IN)  :: contfra(klon, klev)       ! contrails fraction [-]
-  REAL, INTENT(IN)  :: qice_cont(klon, klev)     ! contrails condensed water [kg/kg]
+  REAL, INTENT(IN)  :: contfra(klon, klev)       ! linear contrails fraction [-]
+  REAL, INTENT(IN)  :: perscontfra(klon, klev)   ! contrail induced cirrus fraction [-]
+  REAL, INTENT(IN)  :: qice_cont(klon, klev)     ! linear contrails condensed water [kg/kg]
+  REAL, INTENT(IN)  :: qice_perscont(klon, klev) ! contrail induced cirrus condensed water [kg/kg]
   REAL, INTENT(OUT) :: pch_nocont(klon)          ! 2D high cloud cover without contrails[-]
   REAL, INTENT(OUT) :: pct_cont(klon)            ! 2D total contrails cover[-]
@@ -171,5 +173,6 @@
   REAL zflwp_var, zfiwp_var
   REAL d_rei_dt
-  REAL pclc_var
+  REAL pclc_cont, pclc_perscont
+  REAL rei_cont, rei_perscont
 
 
@@ -252,6 +255,6 @@
       DO k = 1, klev
         DO i = 1, klon
-          pclc_nocont(i,k) = pclc(i, k) - contfra(i, k)
-          xfiwc_nocont(i, k) = xfiwc(i, k) - qice_cont(i, k)
+          pclc_nocont(i,k) = pclc(i, k) - contfra(i, k) - perscontfra(i, k)
+          xfiwc_nocont(i, k) = xfiwc(i, k) - qice_cont(i, k) - qice_perscont(i, k)
         ENDDO
       ENDDO
@@ -393,12 +396,5 @@
 
           IF (zfiwp_var==0. .OR. rei<=0.) rei = 1.
-          IF ( ok_plane_contrail ) THEN
-            !--If contrails are activated, rei is a weighted average between the natural
-            !--rei and the contrails rei, with the weights being the fraction of natural
-            !--vs contrail cirrus in the gridbox
-            !--Beware, re_ice_crystals_contrails is in m, while rei is in microns
-            rei = ( rei * pclc_nocont(i,k) &
-                + re_ice_crystals_contrails * 1.E6 * contfra(i,k) ) / pclc(i,k)
-          ENDIF
+
           pcldtaupi(i, k) = 3.0/2.0*zflwp_var/rad_chaud_pi(i, k) + &
             zfiwp_var*(3.448E-03+2.431/rei)
@@ -687,5 +683,5 @@
           reice_nocont(i,k) = 1.
           pclc_nocont(i,k) = 0.
-          pclc(i,k) = contfra(i,k)
+          pclc(i,k) = contfra(i,k) + perscontfra(i,k)
           pcltau_nocont(i, k) = 0.
           pclemi_nocont(i, k) = 0.
@@ -695,24 +691,49 @@
 
         IF ( contfra(i,k) .GT. 0.01 * seuil_neb ) THEN
+          pclc_cont = contfra(i,k)
+          rei_cont = re_ice_crystals_contrails * 1.E6
+        ELSE
+          pclc_cont = 0.
+          rei_cont = 1.
+        ENDIF
+
+
+        IF ( perscontfra(i,k) .GT. 0.01 * seuil_neb ) THEN
           !--Everything is the same but with contrails
-          zfiwp_var = 1000.*qice_cont(i, k)/contfra(i, k)*rhodz(i, k)
-          pclc_var = contfra(i,k)
-
-          pcltau_cont(i, k) = zfiwp_var*(3.448E-03+2.431/(re_ice_crystals_contrails*1.E6))
+          pclc_perscont = perscontfra(i,k)
+
+          tc = temp(i, k) - 273.15
+          rei_perscont = d_rei_dt*tc + rei_max
+          IF (tc<=-81.4) rei_perscont = rei_min
+
+        ELSE
+          pclc_perscont = 0.
+          rei_perscont = 1.
+        ENDIF
+
+        IF ( MAX(contfra(i,k), perscontfra(i,k)) .GT. 0.01 * seuil_neb ) THEN
+
+          rei = ( rei_cont * pclc_cont + rei_perscont * pclc_perscont ) &
+              / ( pclc_cont + pclc_perscont )
+          zfiwp_var = 1000.*(xfiwc(i, k)-xfiwc_nocont(i, k))&
+                    / (pclc(i, k)-pclc_nocont(i, k))*rhodz(i, k)
+
+          pcltau_cont(i, k) = zfiwp_var*(3.448E-03+2.431/rei)
           ! -- cloud infrared emissivity:
           ! [the broadband infrared absorption coefficient is PARAMETERized
           ! as a function of the effective cld droplet radius]
           ! Ebert and Curry (1992) formula as used by Kiehl & Zender (1995):
-          k_ice = k_ice0 + 1.0/(re_ice_crystals_contrails*1.E6)
+          k_ice = k_ice0 + 1.0/rei
           pclemi_cont(i, k) = 1.0 - exp(-df*k_ice*zfiwp_var)
 
         ELSE
-          pclc_var = 0.
           pcltau_cont(i, k) = 0.
           pclemi_cont(i, k) = 0.
         ENDIF
 
-        rei = ( re_ice_crystals_contrails*1.E6 * pclc_var &
-            + reice_nocont(i, k) * pclc_nocont(i,k) ) / ( pclc_var + pclc_nocont(i,k) )
+
+        rei = ( rei_cont * pclc_cont + rei_perscont * pclc_perscont &
+            + reice_nocont(i, k) * pclc_nocont(i, k) ) &
+            / ( pclc_cont + pclc_perscont + pclc_nocont(i,k) )
 
         zflwp_var = 1000.*xflwc(i, k)/pclc(i, k)*rhodz(i, k)
@@ -861,8 +882,8 @@
     DO k = klev, 1, -1
       DO i = 1, klon
-        zclear(i) = zclear(i)*(1.-max(contfra(i,k),zcloud(i)))/(1.-min(real( &
-          zcloud(i),kind=8),1.-zepsec))
+        zclear(i) = zclear(i)*(1.-max(contfra(i,k)+perscontfra(i,k),zcloud(i)))/&
+          (1.-min(real(zcloud(i),kind=8),1.-zepsec))
         pct_cont(i) = 1. - zclear(i)
-        zcloud(i) = contfra(i,k)
+        zcloud(i) = contfra(i,k) + perscontfra(i,k)
         IF (paprs(i,k)<prmhc) THEN
           pch_nocont(i) = pch_nocont(i)*(1.-max(pclc_nocont(i,k),zcloudh(i)))/(1.-min(real( &
Index: LMDZ6/branches/contrails/libf/phylmd/lmdz_lscp.f90
===================================================================
--- LMDZ6/branches/contrails/libf/phylmd/lmdz_lscp.f90	(revision 5602)
+++ LMDZ6/branches/contrails/libf/phylmd/lmdz_lscp.f90	(revision 5609)
@@ -8,5 +8,6 @@
 SUBROUTINE lscp(klon,klev,dtime,missing_val,            &
      paprs, pplay, omega, temp, qt, ql_seri, qi_seri,   &
-     ptconv, cldfracv, qcondcv, ratqs, sigma_qtherm,    &
+     ratqs, sigma_qtherm, ptconv, cfcon_old, qvcon_old, &
+     qccon_old, cfcon, qvcon, qccon,                    &
      d_t, d_q, d_ql, d_qi, rneb, rneblsvol,             &
      pfraclr, pfracld,                                  &
@@ -24,6 +25,6 @@
      dqi_adj, dqi_sub, dqi_con, dqi_mix, dqvc_adj,      &
      dqvc_sub, dqvc_con, dqvc_mix, qsatl, qsati,        &
-     cfa_seri, qta_seri, flight_dist, flight_h2o,       &
-     qice_cont, Tcritcont,                              &
+     cfa_seri, pcf_seri, qva_seri, qia_seri,flight_dist,&
+     flight_h2o, qice_perscont, Tcritcont,              &
      qcritcont, potcontfraP, potcontfraNP,              &
      cloudth_sth,                                       &
@@ -117,9 +118,10 @@
 USE lmdz_lscp_ini, ONLY : ok_radocond_snow, a_tr_sca
 USE lmdz_lscp_ini, ONLY : iflag_cloudth_vert, iflag_t_glace, iflag_fisrtilp_qsat
-USE lmdz_lscp_ini, ONLY : t_glace_min, min_frac_th_cld
+USE lmdz_lscp_ini, ONLY : t_glace_min, temp_nowater, min_frac_th_cld
 USE lmdz_lscp_ini, ONLY : RCPD, RLSTT, RLVTT, RVTMP2, RTT, RD, RG
 USE lmdz_lscp_ini, ONLY : ok_poprecip, ok_bug_phase_lscp
 USE lmdz_lscp_ini, ONLY : ok_ice_supersat, ok_unadjusted_clouds, iflag_icefrac
-USE lmdz_lscp_ini, ONLY : ok_plane_contrail
+USE lmdz_lscp_ini, ONLY : ok_weibull_warm_clouds, ok_no_issr_strato
+USE lmdz_lscp_ini, ONLY : ok_plane_contrail, ok_ice_sedim
 
 ! Temporary call for Lamquin et al (2012) diagnostics
@@ -153,6 +155,10 @@
                                                                    ! CR: if iflag_ice_thermo=2, only convection is active
   LOGICAL, DIMENSION(klon,klev),   INTENT(IN)   :: ptconv          ! grid points where deep convection scheme is active
-  REAL, DIMENSION(klon,klev),      INTENT(IN)   :: cldfracv        ! cloud fraction from deep convection [-]
-  REAL, DIMENSION(klon,klev),      INTENT(IN)   :: qcondcv         ! in-cloud condensed specific humidity from deep convection [kg/kg]
+  REAL, DIMENSION(klon,klev),      INTENT(IN)   :: cfcon_old       ! cloud fraction from deep convection from previous timestep [-]
+  REAL, DIMENSION(klon,klev),      INTENT(IN)   :: qvcon_old       ! in-cloud vapor specific humidity from deep convection from previous timestep [kg/kg]
+  REAL, DIMENSION(klon,klev),      INTENT(IN)   :: qccon_old       ! in-cloud condensed specific humidity from deep convection from previous timestep [kg/kg]
+  REAL, DIMENSION(klon,klev),      INTENT(IN)   :: cfcon           ! cloud fraction from deep convection [-]
+  REAL, DIMENSION(klon,klev),      INTENT(IN)   :: qvcon           ! in-cloud vapor specific humidity from deep convection [kg/kg]
+  REAL, DIMENSION(klon,klev),      INTENT(IN)   :: qccon           ! in-cloud condensed specific humidity from deep convection [kg/kg]
 
   !Inputs associated with thermal plumes
@@ -185,5 +191,7 @@
   !--------------------------------------------------
   REAL, DIMENSION(klon,klev),      INTENT(INOUT):: cfa_seri         ! linear contrails fraction [-]
-  REAL, DIMENSION(klon,klev),      INTENT(INOUT):: qta_seri         ! linear contrails total specific humidity [kg/kg]
+  REAL, DIMENSION(klon,klev),      INTENT(INOUT):: pcf_seri         ! contrails induced cirrus fraction [-]
+  REAL, DIMENSION(klon,klev),      INTENT(INOUT):: qva_seri         ! linear contrails total specific humidity [kg/kg]
+  REAL, DIMENSION(klon,klev),      INTENT(INOUT):: qia_seri         ! linear contrails total specific humidity [kg/kg]
   REAL, DIMENSION(klon,klev),      INTENT(IN)   :: flight_dist      ! aviation distance flown within the mesh [m/s/mesh]
   REAL, DIMENSION(klon,klev),      INTENT(IN)   :: flight_h2o       ! aviation H2O emitted within the mesh [kgH2O/s/mesh]
@@ -243,5 +251,5 @@
   ! for contrails and aviation
 
-  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: qice_cont      !--condensed water in linear contrails used in the radiation scheme [kg/kg]
+  REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: qice_perscont  !--condensed water in contrail induced cirrus used in the radiation scheme [kg/kg]
   REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: Tcritcont      !--critical temperature for contrail formation [K]
   REAL, DIMENSION(klon,klev),      INTENT(OUT)  :: qcritcont      !--critical specific humidity for contrail formation [kg/kg]
@@ -279,5 +287,5 @@
   ! LOCAL VARIABLES:
   !----------------
-  REAL, DIMENSION(klon) :: qliq_in, qice_in
+  REAL, DIMENSION(klon) :: qliq_in, qice_in, qvc_in, cldfra_in
   REAL, DIMENSION(klon,klev) :: ctot
   REAL, DIMENSION(klon,klev) :: ctot_vol
@@ -307,5 +315,5 @@
   REAL, DIMENSION(klon) :: ztupnew
   REAL, DIMENSION(klon) :: zqvapclr, zqupnew ! for poprecip evap / subl
-  REAL, DIMENSION(klon) :: zqice_sedim ! for sedimentation of ice crystals
+  REAL, DIMENSION(klon) :: cldfra_above, icesed_flux ! for sedimentation of ice crystals
   REAL, DIMENSION(klon) :: zrflclr, zrflcld
   REAL, DIMENSION(klon) :: ziflclr, ziflcld
@@ -324,5 +332,6 @@
   REAL :: delta_z
   ! for contrails
-  REAL, DIMENSION(klon) :: contfra, qcont
+  REAL, DIMENSION(klon) :: contfra, perscontfra, qcont
+  LOGICAL, DIMENSION(klon) :: pt_pron_clds
   !--Added for ice supersaturation (ok_ice_supersat) and contrails (ok_plane_contrail)
   ! Constants used for calculating ratios that are advected (using a parent-child
@@ -424,12 +433,15 @@
 dcf_con(:,:)    = 0.
 dcf_mix(:,:)    = 0.
+dcfsed(:,:)     = 0.
 dqi_adj(:,:)    = 0.
 dqi_sub(:,:)    = 0.
 dqi_con(:,:)    = 0.
 dqi_mix(:,:)    = 0.
+dqised(:,:)     = 0.
 dqvc_adj(:,:)   = 0.
 dqvc_sub(:,:)   = 0.
 dqvc_con(:,:)   = 0.
 dqvc_mix(:,:)   = 0.
+dqvcsed(:,:)    = 0.
 qvc(:)          = 0.
 shear(:)        = 0.
@@ -467,5 +479,6 @@
 zqupnew(:)    = 0.
 zqvapclr(:)   = 0.
-zqice_sedim(:)= 0.
+cldfra_above(:)= 0.
+icesed_flux(:)= 0.
 
 
@@ -506,4 +519,8 @@
         !c_iso init of iso
     ENDDO
+    IF ( ok_ice_supersat ) THEN
+      cldfra_in(:) = cf_seri(:,k)
+      qvc_in(:) = qvc_seri(:,k)
+    ENDIF
 
     ! --------------------------------------------------------------------
@@ -519,10 +536,9 @@
       CALL poprecip_precld(klon, dtime, iftop, paprs(:,k), paprs(:,k+1), pplay(:,k), &
                         zt, ztupnew, zq, zmqc, znebprecipclr, znebprecipcld, &
-                        zqvapclr, zqupnew, zqice_sedim, &
-                        cf_seri(:,k), qvc_seri(:,k), qliq_in, qice_in, &
+                        zqvapclr, zqupnew, icesed_flux, &
+                        cldfra_in, qvc_in, qliq_in, qice_in, &
                         zrfl, zrflclr, zrflcld, &
                         zifl, ziflclr, ziflcld, &
-                        dqreva(:,k), dqssub(:,k), &
-                        dcfsed(:,k), dqvcsed(:,k) &
+                        dqreva(:,k), dqssub(:,k) &
                         )
 
@@ -531,5 +547,5 @@
 
       CALL histprecip_precld(klon, dtime, iftop, paprs(:,k), paprs(:,k+1), pplay(:,k), &
-                        zt, ztupnew, zq, zmqc, zneb, znebprecip, znebprecipclr, &
+                        zt, ztupnew, zq, zmqc, zneb, znebprecip, znebprecipclr, icesed_flux, &
                         zrfl, zrflclr, zrflcld, &
                         zifl, ziflclr, ziflcld, &
@@ -646,4 +662,74 @@
             lognormale(:) = .FALSE.
         
+        ENDIF
+
+
+        IF ( ok_ice_supersat ) THEN
+
+          !--Initialisation
+          IF ( ok_plane_contrail ) THEN
+            contfra(:)     = 0.
+            qcont(:)       = 0.
+            perscontfra(:) = 0.
+          ENDIF
+
+          DO i = 1, klon
+
+            pt_pron_clds(i) = ( ( ( ( zt(i) .LE. temp_nowater ) .OR. ok_weibull_warm_clouds ) &
+                .AND. ( .NOT. ok_no_issr_strato .OR. ( stratomask(i,k) .EQ. 0. ) ) ) &
+                .AND. ( cfcon(i,k) .LT. ( 1. - eps ) ) )
+
+            IF ( pt_pron_clds(i) ) THEN
+
+              !--If deep convection is activated, the condensation scheme activates
+              !--only in the environment. NB. the clear sky fraction will the be
+              !--maximised by 1. - cfcon(i,k)
+              IF ( ptconv(i,k) ) zq(i) = zq(i) - ( qvcon(i,k) + qccon(i,k) ) * cfcon(i,k)
+
+              IF ( ( cfcon(i,k) * qccon(i,k) ) .LT. ( cfcon_old(i,k) * qccon_old(i,k) ) ) THEN
+                !--If deep convection is weakening, we add the clouds that are not anymore
+                !--'in' deep convection to the advected clouds
+                cldfra_in(i) = cldfra_in(i) + MAX(0., cfcon_old(i,k) - cfcon(i,k))
+                qvc_in(i) = qvc_in(i) + qvcon_old(i,k) * MAX(0., cfcon_old(i,k) - cfcon(i,k))
+                qice_in(i) = qice_in(i) + ( qccon_old(i,k) * cfcon_old(i,k) &
+                                          - qccon(i,k) * cfcon(i,k) )
+              ELSEIF ( cfcon(i,k) .GT. cfcon_old(i,k) ) THEN
+                !--Else if deep convection is strengthening, it consumes the existing cloud
+                !--fraction (which does not at this moment represent deep convection)
+                !--NB. if deep convection is strengthening while the fraction decreases,
+                !--clear sky water vapor will be transfered in priority
+                cldfra_in(i) = cldfra_in(i) * ( 1. &
+                             - ( cfcon(i,k) - cfcon_old(i,k) ) / ( 1. - cfcon_old(i,k) ) )
+                qvc_in(i)    = qvc_in(i)    * ( 1. &
+                             - ( cfcon(i,k) - cfcon_old(i,k) ) / ( 1. - cfcon_old(i,k) ) )
+                qice_in(i)   = qice_in(i)   * ( 1. &
+                             - ( cfcon(i,k) - cfcon_old(i,k) ) / ( 1. - cfcon_old(i,k) ) )
+              ENDIF
+
+              !--Barriers
+              cldfra_in(i) = MAX(0., MIN(1. - cfcon(i,k), cldfra_in(i)))
+              qvc_in(i)    = MAX(0., MIN(zq(i), qvc_in(i)))
+              qice_in(i)   = MAX(0., MIN(zq(i) - qvc_in(i), qice_in(i)))
+
+              !--Calculate the shear value (input for condensation and ice supersat)
+              !--Cell thickness [m]
+              delta_z = ( paprs(i,k) - paprs(i,k+1) ) / RG / pplay(i,k) * zt(i) * RD
+              IF ( iftop ) THEN
+                ! top
+                shear(i) = SQRT( ( (u_seri(i,k) - u_seri(i,k-1)) / delta_z )**2. &
+                               + ( (v_seri(i,k) - v_seri(i,k-1)) / delta_z )**2. )
+              ELSEIF ( k .EQ. 1 ) THEN
+                ! surface
+                shear(i) = SQRT( ( (u_seri(i,k+1) - u_seri(i,k)) / delta_z )**2. &
+                               + ( (v_seri(i,k+1) - v_seri(i,k)) / delta_z )**2. )
+              ELSE
+                ! other layers
+                shear(i) = SQRT( ( ( (u_seri(i,k+1) + u_seri(i,k)) / 2. &
+                                   - (u_seri(i,k) + u_seri(i,k-1)) / 2. ) / delta_z )**2. &
+                               + ( ( (v_seri(i,k+1) + v_seri(i,k)) / 2. &
+                                   - (v_seri(i,k) + v_seri(i,k-1)) / 2. ) / delta_z )**2. )
+              ENDIF
+            ENDIF
+          ENDDO
         ENDIF
 
@@ -717,24 +803,9 @@
                   IF (ok_ice_supersat) THEN
 
-                    !--Calculate the shear value (input for condensation and ice supersat)
-                    DO i = 1, klon
-                      !--Cell thickness [m]
-                      delta_z = ( paprs(i,k) - paprs(i,k+1) ) / RG / pplay(i,k) * Tbef(i) * RD
-                      IF ( iftop ) THEN
-                        ! top
-                        shear(i) = SQRT( ( (u_seri(i,k) - u_seri(i,k-1)) / delta_z )**2. &
-                                       + ( (v_seri(i,k) - v_seri(i,k-1)) / delta_z )**2. )
-                      ELSEIF ( k .EQ. 1 ) THEN
-                        ! surface
-                        shear(i) = SQRT( ( (u_seri(i,k+1) - u_seri(i,k)) / delta_z )**2. &
-                                       + ( (v_seri(i,k+1) - v_seri(i,k)) / delta_z )**2. )
-                      ELSE
-                        ! other layers
-                        shear(i) = SQRT( ( ( (u_seri(i,k+1) + u_seri(i,k)) / 2. &
-                                           - (u_seri(i,k) + u_seri(i,k-1)) / 2. ) / delta_z )**2. &
-                                       + ( ( (v_seri(i,k+1) + v_seri(i,k)) / 2. &
-                                           - (v_seri(i,k) + v_seri(i,k-1)) / 2. ) / delta_z )**2. )
-                      ENDIF
-                    ENDDO
+                    IF ( iftop ) THEN
+                      cldfra_above(:) = 0.
+                    ELSE
+                      cldfra_above(:) = rneb(:,k+1)
+                    ENDIF
 
                     !---------------------------------------------
@@ -744,15 +815,15 @@
                     CALL condensation_ice_supersat( &
                         klon, dtime, pplay(:,k), paprs(:,k), paprs(:,k+1), &
-                        cldfracv(:,k), qcondcv(:,k), &
-                        cf_seri(:,k), qvc_seri(:,k), qliq_in, qice_in, &
-                        shear, tke_dissip(:,k), cell_area, stratomask(:,k), &
-                        Tbef, zq, zqs, gammasat, ratqs(:,k), keepgoing, &
+                        cfcon(:,k), cldfra_in, qvc_in, qliq_in, qice_in, &
+                        shear, tke_dissip(:,k), cell_area, Tbef, zq, zqs, &
+                        gammasat, ratqs(:,k), keepgoing, pt_pron_clds, &
+                        cldfra_above, icesed_flux,&
                         rneb(:,k), zqn, qvc, issrfra(:,k), qissr(:,k), &
-                        dcf_sub(:,k), dcf_con(:,k), dcf_mix(:,k), &
-                        dqi_adj(:,k), dqi_sub(:,k), dqi_con(:,k), dqi_mix(:,k), &
-                        dqvc_adj(:,k), dqvc_sub(:,k), dqvc_con(:,k), dqvc_mix(:,k), &
-                        cfa_seri(:,k), qta_seri(:,k), flight_dist(:,k), flight_h2o(:,k), &
-                        contfra, qcont, Tcritcont(:,k), qcritcont(:,k), &
-                        potcontfraP(:,k), potcontfraNP(:,k), &
+                        dcf_sub(:,k), dcf_con(:,k), dcf_mix(:,k), dcfsed(:,k), &
+                        dqi_adj(:,k), dqi_sub(:,k), dqi_con(:,k), dqi_mix(:,k), dqised(:,k), &
+                        dqvc_adj(:,k), dqvc_sub(:,k), dqvc_con(:,k), dqvc_mix(:,k), dqvcsed(:,k), &
+                        cfa_seri(:,k), pcf_seri(:,k), qva_seri(:,k), qia_seri(:,k), &
+                        flight_dist(:,k), flight_h2o(:,k), contfra, perscontfra, qcont, &
+                        Tcritcont(:,k), qcritcont(:,k), potcontfraP(:,k), potcontfraNP(:,k), &
                         dcfa_ini(:,k), dqia_ini(:,k), dqta_ini(:,k), &
                         dcfa_sub(:,k), dqia_sub(:,k), dqta_sub(:,k), &
@@ -951,9 +1022,4 @@
 
     IF (ok_plane_contrail) THEN
-      !!--Contrails do not precipitate. We remove then from the variables temporarily
-      !DO i = 1, klon
-      !  rneb(i,k) = rneb(i,k) - contfra(i)
-      !  zoliqi(i) = zoliqi(i) - ( qcont(i) - zqs(i) * contfra(i) )
-      !ENDDO
       !--Contrails precipitate as natural clouds. We save the partition of ice
       !--between natural clouds and contrails
@@ -975,5 +1041,5 @@
                             ctot_vol(:,k), ptconv(:,k), &
                             zt, zq, zoliql, zoliqi, zfice, &
-                            rneb(:,k), zqice_sedim, znebprecipclr, znebprecipcld, &
+                            rneb(:,k), icesed_flux, znebprecipclr, znebprecipcld, &
                             zrfl, zrflclr, zrflcld, &
                             zifl, ziflclr, ziflcld, &
@@ -991,10 +1057,10 @@
 
       CALL histprecip_postcld(klon, dtime, iftop, paprs(:,k), paprs(:,k+1), pplay(:,k), &
-                            ctot_vol(:,k), ptconv(:,k), zdqsdT_raw, &
-                            zt, zq, zoliq, zoliql, zoliqi, zcond, zfice, zmqc, &
+                            ctot_vol(:,k), ptconv(:,k), pt_pron_clds, zdqsdT_raw, &
+                            zt, zq, zoliq, zoliql, zoliqi, zcond, zfice, zmqc, icesed_flux, &
                             rneb(:,k), znebprecipclr, znebprecipcld, &
                             zneb, tot_zneb, zrho_up, zvelo_up, &
                             zrfl, zrflclr, zrflcld, zifl, ziflclr, ziflcld, &
-                            zradocond, zradoice, dqrauto(:,k), dqsauto(:,k) &
+                            zradocond, zradoice, dqrauto(:,k), dqsauto(:,k), dqised(:,k) &
                             )
 
@@ -1002,9 +1068,4 @@
     
     IF (ok_plane_contrail) THEN
-      !!--Contrails are reintroduced in the variables
-      !DO i = 1, klon
-      !  rneb(i,k) = rneb(i,k) + contfra(i)
-      !  zoliqi(i) = zoliqi(i) + ( qcont(i) - zqs(i) * contfra(i) )
-      !ENDDO
       !--Contrails fraction is left unchanged, but contrails water has changed
       DO i = 1, klon
@@ -1106,19 +1167,32 @@
     ! P6 > write diagnostics and outputs
     !------------------------------------------------------------
+
+    CALL calc_qsat_ecmwf(klon,zt,qzero,pplay(:,k),RTT,1,.false.,qsatl(:,k),zdqs)
+    CALL calc_qsat_ecmwf(klon,zt,qzero,pplay(:,k),RTT,2,.false.,qsati(:,k),zdqs)
    
     !--AB Write diagnostics and tracers for ice supersaturation
     IF ( ok_plane_contrail ) THEN
       cfa_seri(:,k) = contfra(:)
-      qta_seri(:,k) = qcont(:)
-      qice_cont(:,k) = qcont(:) - zqs(:) * contfra(:)
+      pcf_seri(:,k) = perscontfra(:)
+      qva_seri(:,k) = zqs(:) * contfra(:)
+      qia_seri(:,k) = qcont(:) - zqs(:) * contfra(:)
+      DO i = 1, klon
+        IF ( ( rneb(i,k) - cfa_seri(i,k) ) .GT. eps ) THEN
+          qice_perscont(i,k) = ( radocond(i,k) - qia_seri(i,k) ) &
+              * perscontfra(i) / ( rneb(i,k) - cfa_seri(i,k) )
+        ELSE
+          qice_perscont(i,k) = 0.
+        ENDIF
+      ENDDO
     ENDIF
 
-    IF ( ok_ice_supersat .AND. .NOT. ok_unadjusted_clouds) qvc(:) = zqs(:) * rneb(:,k)
-
     IF ( ok_ice_supersat ) THEN
-      CALL calc_qsat_ecmwf(klon,zt,qzero,pplay(:,k),RTT,1,.false.,qsatl(:,k),zdqs)
-      CALL calc_qsat_ecmwf(klon,zt,qzero,pplay(:,k),RTT,2,.false.,qsati(:,k),zdqs)
 
       DO i = 1, klon
+
+        !--If prognostic clouds are activated, deep convection vapor is
+        !--re-added to the total water vapor
+        IF ( ptconv(i,k) .AND. pt_pron_clds(i) ) &
+            zq(i) = zq(i) + ( qvcon(i,k) + qccon(i,k) ) * cfcon(i,k)
 
         cf_seri(i,k) = rneb(i,k)
@@ -1236,4 +1310,10 @@
   ENDDO
 
+  IF ( ok_ice_sedim ) THEN
+    DO i = 1, klon
+      snow(i) = snow(i) + icesed_flux(i)
+    ENDDO
+  ENDIF
+
   IF (ncoreczq>0) THEN
       WRITE(lunout,*)'WARNING : ZQ in LSCP ',ncoreczq,' val < 1.e-15.'
